<?php

namespace app\admin\service\coupon;

use app\model\CouponDetail;
use support\Db;

class CouponService
{
    /**
     * @Desc 优惠券自动过期
     * @Author Gorden
     * @Date 2024/8/26 17:58
     *
     * @return void
     */
    public static function checkCouponExpired()
    {
        $couponDetails = Db::select("select * from app_coupon_detail where (coupon_detail_status = 'INIT' OR coupon_detail_status = 'PENDING' OR coupon_detail_status = 'ACTIVED' OR coupon_detail_status = 'WAITING') AND coupon_detail_deadline_datetime != '' AND CAST(UNIX_TIMESTAMP(coupon_detail_deadline_datetime) as SIGNED) < ".time());
        foreach ($couponDetails as $detail){
            $endTimeUnix = strtotime($detail->coupon_detail_deadline_datetime);
            if ($endTimeUnix < time()){
                CouponDetail::where('coupon_detail_id',$detail->coupon_detail_id)->update(['coupon_detail_status'=>'EXPIRED']);
               echo $detail->coupon_detail_id."已过期\n";
            }
        }
    }
}